/* File name: mfocus.c 
 * Synopsis:  This program allows you to adjust your camera by 
 *            grabbing continuously until a key is pressed.
 */

#include <stdio.h> 
#include <mil.h>
#include <conio.h>
#include <windows.h>

void main(void)
{ 
   MIL_ID MilApplication,  /* Application identifier.  */
          MilSystem,       /* System identifier.       */
          MilDisplay,      /* Display identifier.      */
          MilDigitizer,    /* Digitizer identifier.    */ 
          MilImageTmp, MilImage;        /* Image buffer identifier. */
   long dcf, board, type, data,grabber;
   char dcfname[256];



   printf("Please select the board driver(s) that you want to use :\n\n");
   printf("1- MeteorII Standard/MultiChannel Frame Grabber\n");
   printf("2- MeteorII 1394 Frame Grabber\n");
   printf("3- Orion /STD or Orion /DUAL Frame Grabber\n");
   printf("4- Orion /RGB Frame Grabber\n");

   printf("\nPress 0 for none\n");

   grabber = getch();
   grabber -= 0x30;

   while (grabber < 0 || grabber > 4)
    {
    printf("Please enter a number between 1 and 4\n");
    grabber = getch();
    grabber -= 0x30;
    }

   if ((grabber==1) || (grabber==2) || (grabber==3) || (grabber==4))
       {
           /* Allocate defaults. */
           MappAlloc(M_DEFAULT, &MilApplication);
  
       if (grabber==1) 
           {
           type = M_SYSTEM_METEOR_II_TYPE;
           MsysAlloc(M_SYSTEM_METEOR_II, M_DEF_SYSTEM_NUM, M_SETUP, &MilSystem);
           }
       if (grabber==2)    
           {      
          type = M_SYSTEM_METEOR_II_1394_TYPE;
          MsysAlloc(M_SYSTEM_METEOR_II_1394, M_DEF_SYSTEM_NUM, M_SETUP, &MilSystem);
           }
	   if (grabber==3 || grabber==4)    
           {      
          type = M_SYSTEM_ORION_TYPE;
          MsysAlloc(M_SYSTEM_ORION, M_DEF_SYSTEM_NUM, M_SETUP, &MilSystem);
           }
	    
       MdispAlloc(MilSystem, M_DEFAULT, M_DEF_DISPLAY_FORMAT, M_DEFAULT, &MilDisplay);
       MbufAlloc2d(MilSystem, 512, 480, 8L+M_UNSIGNED, M_IMAGE + M_PROC + M_GRAB + M_DISP, &MilImageTmp);
       MbufClear(MilImageTmp, 0);

       MgraText(M_DEFAULT, MilImageTmp, 176L, 210L, " ------------------ ");
       MgraText(M_DEFAULT, MilImageTmp, 176L, 235L, " Welcome to MIL !!! ");
       MgraText(M_DEFAULT, MilImageTmp, 176L, 260L, " ------------------ ");

       MdispSelect(MilDisplay, MilImageTmp);
       printf("Please enter the camera format you would like to use:\n");

       if ((type == M_SYSTEM_METEOR_II_TYPE) && (grabber==1))        
            board = MsysInquire(MilSystem, M_BOARD_TYPE, M_NULL);
   
           if ((board & 0xff) == M_METEOR_II_MC && (grabber==1))
           {
              printf("1- Rs170 RGB\n");
              printf("2- Ccir RGB\n");
              printf("3- Ntsc RGB\n");
              printf("4- Pal RGB\n");

              printf("\nPress 0 for none\n");
              dcf = getch();
              dcf -= 0x30;

		        while (dcf < 0 || dcf > 4)
		        {
			        printf("Please enter a number between 0 and 4\n");
                 dcf = getch();
                 dcf -= 0x30;
		        }

              if (!dcf)
              {
                 MbufFree(MilImageTmp);
                 MdispFree(MilDisplay);
                 MsysFree(MilSystem);
                 MappFree(MilApplication);
                 exit(0);
              }

		        switch (dcf)
		        {
			        case 1: strcpy(dcfname, "M_RS170_VIA_RGB"); break;
			        case 2: strcpy(dcfname, "M_CCIR_VIA_RGB"); break;
			        case 3: strcpy(dcfname, "M_NTSC_RGB"); break;
			        case 4: strcpy(dcfname, "M_PAL_RGB"); break;
		        }
           }
           else if ((board & 0xff) == M_METEOR_II_STD && (grabber==1))
           {
		        printf("1- Rs170\n");
		        printf("2- Ccir\n");
		        printf("3- Ntsc\n");
		        printf("4- Ntsc Y-C\n");
		        printf("5- Pal\n");
		        printf("6- Pal Y-C\n");

              printf("\nPress 0 for none\n");
              dcf = getch();
              dcf -= 0x30;

		        while (dcf < 0 || dcf > 6)
		        {
			        printf("Please enter a number between 0 and 6\n");
                 dcf = getch();
                 dcf -= 0x30;
              }

              if (!dcf)
              {
                 MbufFree(MilImageTmp);
                 MdispFree(MilDisplay);
                 MsysFree(MilSystem);
                 MappFree(MilApplication);
                 exit(0);
              }

		        switch (dcf)
		        {
			        case 1: strcpy(dcfname, "M_RS170"); break;
			        case 2: strcpy(dcfname, "M_CCIR"); break;
			        case 3: strcpy(dcfname, "M_NTSC"); break;
			        case 4: strcpy(dcfname, "M_NTSC_YC"); break;
			        case 5: strcpy(dcfname, "M_PAL"); break;
			        case 6: strcpy(dcfname, "M_PAL_YC"); break;
		        }
           }
           else if (grabber==2)  // 1394 autodetect use m_default as parapmeter passed
           {
              printf("1- Rs170     \n");
              printf("2- Ntsc      \n");
              printf("3- Default   \n");

              printf("\nPress 0 for none\n");
              data = getch();
              data -= 0x30;

		        while (data < 0 || data > 3)
		        {
			        printf("Please enter a number between 0 and 3\n");
                 data = getch();
                 data -= 0x30;
		        }

              if (!data)
              {                 
                 MbufFree(MilImageTmp);
                 MdispFree(MilDisplay);
                 MsysFree(MilSystem);
                 MappFree(MilApplication);
                 exit(0);
              }

		        switch (data)
		        {
			        case 1: strcpy(dcfname, "M_RS170"); break;			    
			        case 2: strcpy(dcfname, "M_NTSC"); break;
			        case 3: strcpy(dcfname, "M_DEFAULT"); break;
		        }
   
		   }
		   else if(grabber==3)  //Orion STD or Dual Board Selected
		   {
			  printf("1- RS170     \n");
              printf("2- NTSC      \n");
              printf("3- CCIR      \n");
			  printf("4- PAL       \n");

              printf("\nPress 0 for none\n");
              data = getch();
              data -= 0x30;

		        while (data < 0 || data > 4)
		        {
			        printf("Please enter a number between 0 and 4\n");
                 data = getch();
                 data -= 0x30;
		        }

				if (!data)
				{                 
                 MbufFree(MilImageTmp);
                 MdispFree(MilDisplay);
                 MsysFree(MilSystem);
                 MappFree(MilApplication);
                 exit(0);
				}

				switch (data)
		        {
			        case 1: strcpy(dcfname, "M_RS170"); break;			    
			        case 2: strcpy(dcfname, "M_NTSC"); break;
			        case 3: strcpy(dcfname, "M_CCIR"); break;
					case 4: strcpy(dcfname, "M_PAL"); break;
		        }
				
		   }
		   else if(grabber==4)  //Orion RGB Board Selected
		   {
			  printf("1- RS170 RGB     \n");
              printf("2- NTSC RGB      \n");
              printf("3- CCIR RGB      \n");
			  printf("4- PAL RGB       \n");

              printf("\nPress 0 for none\n");
              data = getch();
              data -= 0x30;

		        while (data < 0 || data > 4)
		        {
			        printf("Please enter a number between 0 and 4\n");
                 data = getch();
                 data -= 0x30;
		        }

				if (!data)
				{                 
                 MbufFree(MilImageTmp);
                 MdispFree(MilDisplay);
                 MsysFree(MilSystem);
                 MappFree(MilApplication);
                 exit(0);
				}

				switch (data)
		        {
			        case 1: strcpy(dcfname, "M_RS170_VIA_RGB"); break;			    
			        case 2: strcpy(dcfname, "M_NTSC_RGB"); break;
			        case 3: strcpy(dcfname, "M_CCIR_VIA_RGB"); break;
					case 4: strcpy(dcfname, "M_PAL_RGB"); break;
		        }
				
		   }
    

       MdigAlloc(MilSystem, M_DEFAULT, dcfname, M_DEFAULT, &MilDigitizer);

       MbufAllocColor(MilSystem,
                      MdigInquire(MilDigitizer, M_SIZE_BAND, M_NULL), 
                      MdigInquire(MilDigitizer, M_SIZE_X, M_NULL), 
                      MdigInquire(MilDigitizer, M_SIZE_Y, M_NULL), 
                      8L+M_UNSIGNED, 
                      M_IMAGE + M_PROC + M_GRAB + M_DISP, 
                      &MilImage);

       MbufClear(MilImage, 0);
       MdispSelect(MilDisplay, MilImage);   

       MbufFree(MilImageTmp);

       /* Grab continuously. */
       MdigGrabContinuous(MilDigitizer, MilImage);

       /* When a key is pressed, halt. */
       printf("Continuous grab in progress. Adjust your camera and\n");
       printf("press <Enter> to stop grabbing.\n");
       getchar();

       /* Stop continuous grab. */
       MdigHalt(MilDigitizer);

       /* Pause to show the result. */
       printf("\nDisplaying the last grabbed image.\n");
       printf("Press <Enter> to end.\n");
       getchar();
   
       /* Release defaults. */
       MappFreeDefault(MilApplication, MilSystem, MilDisplay,
                                      MilDigitizer, MilImage);
       }    

}

